package scalapi.jdk.control

object Use {

  def apply[C <: {def close()}, R]
  (closeable: C)
  (closableHandler: C => R): R = {
    try {
      closableHandler(closeable)
    } finally {
      closeable.close()
    }
  }

  class ClosablePimp[C <: {def close()}](closable: C) {

    def use[R](closableHandler: C => R): R = Use(closable)(closableHandler)

  }

}